﻿@if (AddedTags.Count < Count)
{
    <MudAutocomplete T="string" Label="タグ追加" @bind-Value="tag" SearchFunc="@SearchTags" CoerceValue="true"
                     HelperText="@($"このプログラムに関するキーワードを{Count}つまで。")"
                     Adornment="Adornment.End" AdornmentIcon="@Icons.Material.Filled.Add" OnAdornmentClick="Add" />
}

<MudChipSet AllClosable="true" OnClose="Closed">
    @foreach (var addedTag in AddedTags)
    {
        <MudChip Text="@addedTag" Link="@($"/program-list/{addedTag}")"></MudChip>
    }
</MudChipSet>

@code {
    [Parameter]
    public int Count { get; set; }

    [Parameter]
    public List<string> AddedTags { get; set; }

    [Parameter]
    public EventCallback<List<string>> AddedTagsChanged { get; set; }

    string tag;

    private IEnumerable<TagEntity> tags = new List<TagEntity>();

    protected async override Task OnInitializedAsync()
    {
        tags = await HttpClient.GetFromJsonAsync<List<TagEntity>>($"api/Tags");
        foreach (var tag in tags)
        {
            states.Add(tag.TagName);
        }
    }
    public void Add()
    {
        if (string.IsNullOrWhiteSpace(tag))
        {
            return;
        }
        if (AddedTags.Where(a => a.Contains(tag)).Any())
        {
            Snackbar.Add("既に登録されています。", Severity.Error);
            return;
        }
        AddedTags.Add(tag);
        if (AddedTagsChanged.HasDelegate)
        {
            AddedTagsChanged.InvokeAsync(AddedTags);
        }
        tag = string.Empty;
        StateHasChanged();
    }

    public void Closed(MudChip chip)
    {
        AddedTags.Remove(chip.Text);
        if (AddedTagsChanged.HasDelegate)
        {
            AddedTagsChanged.InvokeAsync(AddedTags);
        }
    }

    private List<string> states = new();

    private async Task<IEnumerable<string>> SearchTags(string value)
    {
        // In real life use an asynchronous function for fetching data from an api.
        await Task.Delay(5);

        // if text is null or empty, show complete list
        if (string.IsNullOrEmpty(value))
            return states;
        return states.Where(x => x.Contains(value, StringComparison.InvariantCultureIgnoreCase));
    }

}